package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;
    public static boolean dontPause;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        if (!dontPause)
            BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        else
            BA.LogInfo("** Activity (main) Pause event (activity is not paused). **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        if (!dontPause) {
            processBA.setActivityPaused(true);
            mostCurrent = null;
        }

        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _btadmin = null;
public static anywheresoftware.b4a.objects.Serial _btserial = null;
public static anywheresoftware.b4a.objects.collections.List _btdevicess = null;
public static b4a.example.main._nameandmac _connecteddevice = null;
public static boolean _connectedflag = false;
public static boolean _bluetoothstate = false;
public static anywheresoftware.b4a.randomaccessfile.AsyncStreams _async = null;
public static anywheresoftware.b4a.objects.RuntimePermissions _rp = null;
public anywheresoftware.b4a.objects.ButtonWrapper _search = null;
public anywheresoftware.b4a.objects.ButtonWrapper _conn = null;
public anywheresoftware.b4a.objects.ButtonWrapper _program = null;
public static String _stringdata = "";
public static int[] _bytestosend = null;
public static byte[] _bytes2send = null;
public static byte _numberofled = (byte)0;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checks = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkf = null;
public anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper _checkc = null;
public anywheresoftware.b4a.objects.PanelWrapper _chcolor = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _radiopower = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _radioblue = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _radiogreen = null;
public anywheresoftware.b4a.objects.SeekBarWrapper _radiored = null;
public b4a.example.starter _starter = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static class _nameandmac{
public boolean IsInitialized;
public String Name;
public String Mac;
public void Initialize() {
IsInitialized = true;
Name = "";
Mac = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 63;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 65;BA.debugLine="Activity.LoadLayout(\"aledc\")";
mostCurrent._activity.LoadLayout("aledc",mostCurrent.activityBA);
 //BA.debugLineNum = 66;BA.debugLine="Activity.Title=\"Ambiente BT LED Controler\"";
mostCurrent._activity.setTitle(BA.ObjectToCharSequence("Ambiente BT LED Controler"));
 //BA.debugLineNum = 78;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 79;BA.debugLine="connectedflag = False";
_connectedflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 80;BA.debugLine="BTadmin.Initialize(\"BTadmin\")";
_btadmin.Initialize(processBA,"BTadmin");
 //BA.debugLineNum = 81;BA.debugLine="BTserial.Initialize(\"BTserial\")";
_btserial.Initialize("BTserial");
 //BA.debugLineNum = 83;BA.debugLine="conn.Text=\"Disconnect\"   'napisanie na przycisku";
mostCurrent._conn.setText(BA.ObjectToCharSequence("Disconnect"));
 //BA.debugLineNum = 84;BA.debugLine="conn.Enabled=False";
mostCurrent._conn.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 85;BA.debugLine="Program.Enabled=False 'wylaczenie przycisku do w";
mostCurrent._program.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 86;BA.debugLine="search.Enabled=True";
mostCurrent._search.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 88;BA.debugLine="sliderdefault  'ustalenie poczatkowych wartosci";
_sliderdefault();
 //BA.debugLineNum = 89;BA.debugLine="sliderpanel   'ustalenie wartosci kolorow, dla p";
_sliderpanel();
 //BA.debugLineNum = 90;BA.debugLine="numberofled=0 'wybranie pierwszej wartosci dla c";
_numberofled = (byte) (0);
 //BA.debugLineNum = 91;BA.debugLine="checkerchange(numberofled) '";
_checkerchange(_numberofled);
 };
 //BA.debugLineNum = 94;BA.debugLine="If BTadmin.IsEnabled = False Then";
if (_btadmin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 95;BA.debugLine="If BTadmin.Enable = False Then";
if (_btadmin.Enable()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 96;BA.debugLine="ToastMessageShow(\"Error enabling Bluetooth adap";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Error enabling Bluetooth adapter."),anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 98;BA.debugLine="ToastMessageShow(\"Enabling Bluetooth adapter...";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Enabling Bluetooth adapter..."),anywheresoftware.b4a.keywords.Common.False);
 };
 }else {
 //BA.debugLineNum = 101;BA.debugLine="BluetoothState = True";
_bluetoothstate = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 104;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 112;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 113;BA.debugLine="If UserClosed Then";
if (_userclosed) { 
 //BA.debugLineNum = 114;BA.debugLine="async.Close         'zamkniecie aplikacji";
_async.Close();
 //BA.debugLineNum = 115;BA.debugLine="BTserial.Disconnect 'zamkniecie polaczenia szere";
_btserial.Disconnect();
 //BA.debugLineNum = 116;BA.debugLine="connectedflag=False 'wykasowanie flagi informuja";
_connectedflag = anywheresoftware.b4a.keywords.Common.False;
 };
 //BA.debugLineNum = 118;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 107;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 109;BA.debugLine="End Sub";
return "";
}
public static String  _async_newdata(byte[] _buffer) throws Exception{
 //BA.debugLineNum = 294;BA.debugLine="Sub async_NewData (Buffer() As Byte)";
 //BA.debugLineNum = 296;BA.debugLine="End Sub";
return "";
}
public static String  _btadmin_devicefound(String _name,String _macaddress) throws Exception{
b4a.example.main._nameandmac _nm = null;
 //BA.debugLineNum = 124;BA.debugLine="Sub BTadmin_DeviceFound (Name As String, MacAddres";
 //BA.debugLineNum = 125;BA.debugLine="Log(Name & \":\" & MacAddress)";
anywheresoftware.b4a.keywords.Common.LogImpl("3327681",_name+":"+_macaddress,0);
 //BA.debugLineNum = 126;BA.debugLine="Dim nm As NameAndMac";
_nm = new b4a.example.main._nameandmac();
 //BA.debugLineNum = 127;BA.debugLine="nm.Name = Name";
_nm.Name /*String*/  = _name;
 //BA.debugLineNum = 128;BA.debugLine="nm.Mac = MacAddress";
_nm.Mac /*String*/  = _macaddress;
 //BA.debugLineNum = 129;BA.debugLine="BTdevicess.Add(nm)";
_btdevicess.Add((Object)(_nm));
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
public static void  _btadmin_discoveryfinished() throws Exception{
ResumableSub_BTadmin_DiscoveryFinished rsub = new ResumableSub_BTadmin_DiscoveryFinished(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_BTadmin_DiscoveryFinished extends BA.ResumableSub {
public ResumableSub_BTadmin_DiscoveryFinished(b4a.example.main parent) {
this.parent = parent;
}
b4a.example.main parent;
anywheresoftware.b4a.objects.collections.List _l = null;
b4a.example.main._nameandmac _nm = null;
int _index = 0;
b4a.example.main._nameandmac _device = null;
anywheresoftware.b4a.BA.IterableList group7;
int index7;
int groupLen7;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 133;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 134;BA.debugLine="If BTdevicess.Size = 0 Then";
if (true) break;

case 1:
//if
this.state = 14;
if (parent._btdevicess.getSize()==0) { 
this.state = 3;
}else {
this.state = 5;
}if (true) break;

case 3:
//C
this.state = 14;
 //BA.debugLineNum = 135;BA.debugLine="ToastMessageShow(\"No device found.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("No device found."),anywheresoftware.b4a.keywords.Common.True);
 if (true) break;

case 5:
//C
this.state = 6;
 //BA.debugLineNum = 137;BA.debugLine="Dim l As List";
_l = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 138;BA.debugLine="l.Initialize";
_l.Initialize();
 //BA.debugLineNum = 139;BA.debugLine="For Each nm As NameAndMac In BTdevicess";
if (true) break;

case 6:
//for
this.state = 9;
group7 = parent._btdevicess;
index7 = 0;
groupLen7 = group7.getSize();
this.state = 15;
if (true) break;

case 15:
//C
this.state = 9;
if (index7 < groupLen7) {
this.state = 8;
_nm = (b4a.example.main._nameandmac)(group7.Get(index7));}
if (true) break;

case 16:
//C
this.state = 15;
index7++;
if (true) break;

case 8:
//C
this.state = 16;
 //BA.debugLineNum = 140;BA.debugLine="l.Add(nm.Name)";
_l.Add((Object)(_nm.Name /*String*/ ));
 if (true) break;
if (true) break;

case 9:
//C
this.state = 10;
;
 //BA.debugLineNum = 142;BA.debugLine="InputListAsync(l, \"Choose device\", -1, True)";
anywheresoftware.b4a.keywords.Common.InputListAsync(_l,BA.ObjectToCharSequence("Choose device"),(int) (-1),processBA,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 143;BA.debugLine="Wait For InputList_Result (Index As Int)";
anywheresoftware.b4a.keywords.Common.WaitFor("inputlist_result", processBA, this, null);
this.state = 17;
return;
case 17:
//C
this.state = 10;
_index = (Integer) result[0];
;
 //BA.debugLineNum = 144;BA.debugLine="If Index <> DialogResponse.CANCEL Then";
if (true) break;

case 10:
//if
this.state = 13;
if (_index!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
this.state = 12;
}if (true) break;

case 12:
//C
this.state = 13;
 //BA.debugLineNum = 145;BA.debugLine="Dim device As NameAndMac = BTdevicess.Get(Index";
_device = (b4a.example.main._nameandmac)(parent._btdevicess.Get(_index));
 //BA.debugLineNum = 146;BA.debugLine="BTserial.Connect(device.Mac)";
parent._btserial.Connect(processBA,_device.Mac /*String*/ );
 //BA.debugLineNum = 147;BA.debugLine="ProgressDialogShow2($\"Trying to connect to: ${d";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow2(mostCurrent.activityBA,BA.ObjectToCharSequence(("Trying to connect to: "+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_device.Name /*String*/ ))+" ("+anywheresoftware.b4a.keywords.Common.SmartStringFormatter("",(Object)(_device.Mac /*String*/ ))+")")),anywheresoftware.b4a.keywords.Common.False);
 if (true) break;

case 13:
//C
this.state = 14;
;
 if (true) break;

case 14:
//C
this.state = -1;
;
 //BA.debugLineNum = 150;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _inputlist_result(int _index) throws Exception{
}
public static String  _btadmin_statechanged(int _newstate,int _oldstate) throws Exception{
 //BA.debugLineNum = 152;BA.debugLine="Sub BTadmin_StateChanged (NewState As Int, OldStat";
 //BA.debugLineNum = 153;BA.debugLine="Log(\"state changed: \" & NewState)";
anywheresoftware.b4a.keywords.Common.LogImpl("3458753","state changed: "+BA.NumberToString(_newstate),0);
 //BA.debugLineNum = 154;BA.debugLine="BluetoothState = NewState = BTadmin.STATE_ON";
_bluetoothstate = _newstate==_btadmin.STATE_ON;
 //BA.debugLineNum = 155;BA.debugLine="End Sub";
return "";
}
public static String  _btserial_connected(boolean _success) throws Exception{
 //BA.debugLineNum = 161;BA.debugLine="Sub BTserial_Connected (Success As Boolean)";
 //BA.debugLineNum = 162;BA.debugLine="ProgressDialogHide";
anywheresoftware.b4a.keywords.Common.ProgressDialogHide();
 //BA.debugLineNum = 164;BA.debugLine="If Success Then";
if (_success) { 
 //BA.debugLineNum = 165;BA.debugLine="ToastMessageShow(\"BT is connected\", False )";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("BT is connected"),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 166;BA.debugLine="connectedflag = True";
_connectedflag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 167;BA.debugLine="If async.IsInitialized Then async.Close 'jezeli";
if (_async.IsInitialized()) { 
_async.Close();};
 //BA.debugLineNum = 168;BA.debugLine="async.Initialize(BTserial.InputStream, BTserial.";
_async.Initialize(processBA,_btserial.getInputStream(),_btserial.getOutputStream(),"async");
 //BA.debugLineNum = 169;BA.debugLine="buttonstatus(connectedflag) 'zmiana statusu przy";
_buttonstatus(_connectedflag);
 }else {
 //BA.debugLineNum = 171;BA.debugLine="connectedflag = False";
_connectedflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 172;BA.debugLine="ToastMessageShow(\"Troubles with connection\", Fal";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Troubles with connection"),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 173;BA.debugLine="buttonstatus(connectedflag) 'zmiana statusu przy";
_buttonstatus(_connectedflag);
 };
 //BA.debugLineNum = 175;BA.debugLine="End Sub";
return "";
}
public static String  _buttonstatus(boolean _status) throws Exception{
 //BA.debugLineNum = 218;BA.debugLine="Sub buttonstatus(status As Boolean)";
 //BA.debugLineNum = 219;BA.debugLine="If status=True Then";
if (_status==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 220;BA.debugLine="conn.Enabled=True 'aktywowanie przycisku do rozl";
mostCurrent._conn.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 221;BA.debugLine="search.Enabled=False";
mostCurrent._search.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 223;BA.debugLine="Program.Enabled=True 'aktywowanie przycisku uruc";
mostCurrent._program.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 225;BA.debugLine="conn.Enabled=False 'wylaczenie przycisku do rozl";
mostCurrent._conn.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 226;BA.debugLine="Program.Enabled=False 'wylaczenie przycisku uruc";
mostCurrent._program.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 227;BA.debugLine="search.Enabled=True";
mostCurrent._search.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 229;BA.debugLine="End Sub";
return "";
}
public static String  _checkc_checkedchange(boolean _checked) throws Exception{
 //BA.debugLineNum = 344;BA.debugLine="Private Sub checkc_CheckedChange(Checked As Boolea";
 //BA.debugLineNum = 345;BA.debugLine="If checkc.Checked Then";
if (mostCurrent._checkc.getChecked()) { 
 //BA.debugLineNum = 346;BA.debugLine="numberofled=2";
_numberofled = (byte) (2);
 //BA.debugLineNum = 347;BA.debugLine="checkerchange(numberofled)";
_checkerchange(_numberofled);
 };
 //BA.debugLineNum = 349;BA.debugLine="End Sub";
return "";
}
public static String  _checkerchange(byte _number) throws Exception{
 //BA.debugLineNum = 261;BA.debugLine="Sub checkerchange(number As Byte)";
 //BA.debugLineNum = 262;BA.debugLine="If number=0 Then";
if (_number==0) { 
 //BA.debugLineNum = 263;BA.debugLine="checks.Checked=True";
mostCurrent._checks.setChecked(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 264;BA.debugLine="checkf.Checked=False";
mostCurrent._checkf.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 265;BA.debugLine="checkc.Checked=False";
mostCurrent._checkc.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 267;BA.debugLine="checks.Enabled=False";
mostCurrent._checks.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 268;BA.debugLine="checkf.Enabled=True";
mostCurrent._checkf.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 269;BA.debugLine="checkc.Enabled=True";
mostCurrent._checkc.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 271;BA.debugLine="If number=1 Then";
if (_number==1) { 
 //BA.debugLineNum = 272;BA.debugLine="checks.Checked=False";
mostCurrent._checks.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 273;BA.debugLine="checkf.Checked=True";
mostCurrent._checkf.setChecked(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 274;BA.debugLine="checkc.Checked=False";
mostCurrent._checkc.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 276;BA.debugLine="checks.Enabled=True";
mostCurrent._checks.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 277;BA.debugLine="checkf.Enabled=False";
mostCurrent._checkf.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 278;BA.debugLine="checkc.Enabled=True";
mostCurrent._checkc.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 280;BA.debugLine="If number=2 Then";
if (_number==2) { 
 //BA.debugLineNum = 281;BA.debugLine="checks.Checked=False";
mostCurrent._checks.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 282;BA.debugLine="checkf.Checked=False";
mostCurrent._checkf.setChecked(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 283;BA.debugLine="checkc.Checked=True";
mostCurrent._checkc.setChecked(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 285;BA.debugLine="checks.Enabled=True";
mostCurrent._checks.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 286;BA.debugLine="checkf.Enabled=True";
mostCurrent._checkf.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 287;BA.debugLine="checkc.Enabled=False";
mostCurrent._checkc.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 };
 //BA.debugLineNum = 289;BA.debugLine="End Sub";
return "";
}
public static String  _checkf_checkedchange(boolean _checked) throws Exception{
 //BA.debugLineNum = 337;BA.debugLine="Private Sub checkf_CheckedChange(Checked As Boolea";
 //BA.debugLineNum = 338;BA.debugLine="If checkf.Checked Then";
if (mostCurrent._checkf.getChecked()) { 
 //BA.debugLineNum = 339;BA.debugLine="numberofled=1";
_numberofled = (byte) (1);
 //BA.debugLineNum = 340;BA.debugLine="checkerchange(numberofled)";
_checkerchange(_numberofled);
 };
 //BA.debugLineNum = 342;BA.debugLine="End Sub";
return "";
}
public static String  _checks_checkedchange(boolean _checked) throws Exception{
 //BA.debugLineNum = 330;BA.debugLine="Private Sub checks_CheckedChange(Checked As Boolea";
 //BA.debugLineNum = 331;BA.debugLine="If checks.Checked Then";
if (mostCurrent._checks.getChecked()) { 
 //BA.debugLineNum = 332;BA.debugLine="numberofled=0";
_numberofled = (byte) (0);
 //BA.debugLineNum = 333;BA.debugLine="checkerchange(numberofled)";
_checkerchange(_numberofled);
 };
 //BA.debugLineNum = 335;BA.debugLine="End Sub";
return "";
}
public static String  _conn_click() throws Exception{
 //BA.debugLineNum = 206;BA.debugLine="Sub Conn_Click";
 //BA.debugLineNum = 207;BA.debugLine="If connectedflag=True Then";
if (_connectedflag==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 208;BA.debugLine="async.Close";
_async.Close();
 //BA.debugLineNum = 209;BA.debugLine="BTserial.Disconnect 'zamkniecie polaczenia szere";
_btserial.Disconnect();
 //BA.debugLineNum = 210;BA.debugLine="connectedflag=False  'wykasowanie flagi informuj";
_connectedflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 211;BA.debugLine="buttonstatus(connectedflag) 'zmiana statusu przy";
_buttonstatus(_connectedflag);
 }else {
 //BA.debugLineNum = 213;BA.debugLine="connectedflag=True";
_connectedflag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 214;BA.debugLine="buttonstatus(connectedflag) 'zmiana statusu przy";
_buttonstatus(_connectedflag);
 };
 //BA.debugLineNum = 216;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 40;BA.debugLine="Private search As Button";
mostCurrent._search = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Private conn As Button";
mostCurrent._conn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Private Program As Button";
mostCurrent._program = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim stringdata As String 'zmienna pomocnicza do w";
mostCurrent._stringdata = "";
 //BA.debugLineNum = 45;BA.debugLine="Dim bytestosend(10) As Int    'zmienna pomocnicza";
_bytestosend = new int[(int) (10)];
;
 //BA.debugLineNum = 46;BA.debugLine="Dim bytes2send(10) As Byte";
_bytes2send = new byte[(int) (10)];
;
 //BA.debugLineNum = 47;BA.debugLine="Dim numberofled As Byte";
_numberofled = (byte)0;
 //BA.debugLineNum = 50;BA.debugLine="Private checks As CheckBox";
mostCurrent._checks = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 51;BA.debugLine="Private checkf As CheckBox";
mostCurrent._checkf = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 52;BA.debugLine="Private checkc As CheckBox";
mostCurrent._checkc = new anywheresoftware.b4a.objects.CompoundButtonWrapper.CheckBoxWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Private chcolor As Panel";
mostCurrent._chcolor = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 56;BA.debugLine="Private radiopower As SeekBar";
mostCurrent._radiopower = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 57;BA.debugLine="Private radioblue As SeekBar";
mostCurrent._radioblue = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 58;BA.debugLine="Private radiogreen As SeekBar";
mostCurrent._radiogreen = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 59;BA.debugLine="Private radiored As SeekBar";
mostCurrent._radiored = new anywheresoftware.b4a.objects.SeekBarWrapper();
 //BA.debugLineNum = 60;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 24;BA.debugLine="Dim BTadmin As BluetoothAdmin";
_btadmin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 25;BA.debugLine="Dim BTserial As Serial";
_btserial = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 26;BA.debugLine="Dim BTdevicess As List";
_btdevicess = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 27;BA.debugLine="Type NameAndMac( Name As String, Mac As String )";
;
 //BA.debugLineNum = 28;BA.debugLine="Dim connectedDevice As NameAndMac";
_connecteddevice = new b4a.example.main._nameandmac();
 //BA.debugLineNum = 30;BA.debugLine="Dim connectedflag As Boolean";
_connectedflag = false;
 //BA.debugLineNum = 31;BA.debugLine="Dim BluetoothState As Boolean";
_bluetoothstate = false;
 //BA.debugLineNum = 32;BA.debugLine="Dim async As AsyncStreams";
_async = new anywheresoftware.b4a.randomaccessfile.AsyncStreams();
 //BA.debugLineNum = 34;BA.debugLine="Private rp As RuntimePermissions 'zmienna dostepo";
_rp = new anywheresoftware.b4a.objects.RuntimePermissions();
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _program_click() throws Exception{
 //BA.debugLineNum = 300;BA.debugLine="Sub Program_Click";
 //BA.debugLineNum = 301;BA.debugLine="bytes2send(0)=0x73   's";
_bytes2send[(int) (0)] = (byte) (0x73);
 //BA.debugLineNum = 302;BA.debugLine="bytes2send(1)=0x3a   ':";
_bytes2send[(int) (1)] = (byte) (0x3a);
 //BA.debugLineNum = 303;BA.debugLine="bytes2send(2)=0x30+numberofled   'adres ktore led";
_bytes2send[(int) (2)] = (byte) (0x30+_numberofled);
 //BA.debugLineNum = 304;BA.debugLine="bytes2send(7)=0x6b";
_bytes2send[(int) (7)] = (byte) (0x6b);
 //BA.debugLineNum = 305;BA.debugLine="bytes2send(8)=0x00";
_bytes2send[(int) (8)] = (byte) (0x00);
 //BA.debugLineNum = 306;BA.debugLine="bytes2send(9)=0x00";
_bytes2send[(int) (9)] = (byte) (0x00);
 //BA.debugLineNum = 308;BA.debugLine="async.Write(bytes2send) 'dwa razy wyslanie komend";
_async.Write(_bytes2send);
 //BA.debugLineNum = 309;BA.debugLine="async.Write(bytes2send)";
_async.Write(_bytes2send);
 //BA.debugLineNum = 310;BA.debugLine="End Sub";
return "";
}
public static String  _radioblue_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 322;BA.debugLine="Private Sub radioblue_ValueChanged (Value As Int,";
 //BA.debugLineNum = 323;BA.debugLine="sliderpanel";
_sliderpanel();
 //BA.debugLineNum = 324;BA.debugLine="End Sub";
return "";
}
public static String  _radiogreen_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 318;BA.debugLine="Private Sub radiogreen_ValueChanged (Value As Int,";
 //BA.debugLineNum = 319;BA.debugLine="sliderpanel";
_sliderpanel();
 //BA.debugLineNum = 320;BA.debugLine="End Sub";
return "";
}
public static String  _radiopower_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 326;BA.debugLine="Private Sub radiopower_ValueChanged (Value As Int,";
 //BA.debugLineNum = 327;BA.debugLine="sliderpanel";
_sliderpanel();
 //BA.debugLineNum = 328;BA.debugLine="End Sub";
return "";
}
public static String  _radiored_valuechanged(int _value,boolean _userchanged) throws Exception{
 //BA.debugLineNum = 314;BA.debugLine="Private Sub radiored_ValueChanged (Value As Int, U";
 //BA.debugLineNum = 315;BA.debugLine="sliderpanel";
_sliderpanel();
 //BA.debugLineNum = 316;BA.debugLine="End Sub";
return "";
}
public static void  _search_click() throws Exception{
ResumableSub_search_Click rsub = new ResumableSub_search_Click(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_search_Click extends BA.ResumableSub {
public ResumableSub_search_Click(b4a.example.main parent) {
this.parent = parent;
}
b4a.example.main parent;
String _permission = "";
boolean _result = false;
boolean _temporary = false;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 185;BA.debugLine="rp.CheckAndRequest(rp.PERMISSION_ACCESS_COARSE_LO";
parent._rp.CheckAndRequest(processBA,parent._rp.PERMISSION_ACCESS_COARSE_LOCATION);
 //BA.debugLineNum = 188;BA.debugLine="Wait For Activity_PermissionResult (Permission As";
anywheresoftware.b4a.keywords.Common.WaitFor("activity_permissionresult", processBA, this, null);
this.state = 11;
return;
case 11:
//C
this.state = 1;
_permission = (String) result[0];
_result = (Boolean) result[1];
;
 //BA.debugLineNum = 189;BA.debugLine="If Result = False Then";
if (true) break;

case 1:
//if
this.state = 4;
if (_result==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 190;BA.debugLine="ToastMessageShow(\"Acces location failed\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Acces location failed"),anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 191;BA.debugLine="Return";
if (true) return ;
 if (true) break;

case 4:
//C
this.state = 5;
;
 //BA.debugLineNum = 194;BA.debugLine="BTdevicess.Initialize";
parent._btdevicess.Initialize();
 //BA.debugLineNum = 195;BA.debugLine="Dim temporary As Boolean = False";
_temporary = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 196;BA.debugLine="temporary= BTadmin.StartDiscovery";
_temporary = parent._btadmin.StartDiscovery();
 //BA.debugLineNum = 198;BA.debugLine="If temporary = False Then";
if (true) break;

case 5:
//if
this.state = 10;
if (_temporary==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 7;
}else {
this.state = 9;
}if (true) break;

case 7:
//C
this.state = 10;
 //BA.debugLineNum = 199;BA.debugLine="ToastMessageShow( \"BT Error. Try Again\", True )";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("BT Error. Try Again"),anywheresoftware.b4a.keywords.Common.True);
 if (true) break;

case 9:
//C
this.state = 10;
 //BA.debugLineNum = 201;BA.debugLine="ProgressDialogShow2(\"Searching for devices...\",";
anywheresoftware.b4a.keywords.Common.ProgressDialogShow2(mostCurrent.activityBA,BA.ObjectToCharSequence("Searching for devices..."),anywheresoftware.b4a.keywords.Common.False);
 if (true) break;

case 10:
//C
this.state = -1;
;
 //BA.debugLineNum = 203;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _activity_permissionresult(String _permission,boolean _result) throws Exception{
}
public static String  _sliderdefault() throws Exception{
 //BA.debugLineNum = 247;BA.debugLine="Sub sliderdefault";
 //BA.debugLineNum = 249;BA.debugLine="radiopower.Max=254";
mostCurrent._radiopower.setMax((int) (254));
 //BA.debugLineNum = 250;BA.debugLine="radiored.Max=254";
mostCurrent._radiored.setMax((int) (254));
 //BA.debugLineNum = 251;BA.debugLine="radiogreen.Max=254";
mostCurrent._radiogreen.setMax((int) (254));
 //BA.debugLineNum = 252;BA.debugLine="radioblue.Max=254";
mostCurrent._radioblue.setMax((int) (254));
 //BA.debugLineNum = 254;BA.debugLine="radiopower.Value=254";
mostCurrent._radiopower.setValue((int) (254));
 //BA.debugLineNum = 255;BA.debugLine="radiored.Value=254";
mostCurrent._radiored.setValue((int) (254));
 //BA.debugLineNum = 256;BA.debugLine="radiogreen.Value=254";
mostCurrent._radiogreen.setValue((int) (254));
 //BA.debugLineNum = 257;BA.debugLine="radioblue.Value=254";
mostCurrent._radioblue.setValue((int) (254));
 //BA.debugLineNum = 259;BA.debugLine="End Sub";
return "";
}
public static String  _sliderpanel() throws Exception{
 //BA.debugLineNum = 231;BA.debugLine="Sub sliderpanel";
 //BA.debugLineNum = 233;BA.debugLine="bytestosend(3)=radiopower.Value";
_bytestosend[(int) (3)] = mostCurrent._radiopower.getValue();
 //BA.debugLineNum = 234;BA.debugLine="bytestosend(4)=radiored.Value";
_bytestosend[(int) (4)] = mostCurrent._radiored.getValue();
 //BA.debugLineNum = 235;BA.debugLine="bytestosend(5)=radiogreen.Value";
_bytestosend[(int) (5)] = mostCurrent._radiogreen.getValue();
 //BA.debugLineNum = 236;BA.debugLine="bytestosend(6)=radioblue.Value";
_bytestosend[(int) (6)] = mostCurrent._radioblue.getValue();
 //BA.debugLineNum = 238;BA.debugLine="bytes2send(3)=bytestosend(3)";
_bytes2send[(int) (3)] = (byte) (_bytestosend[(int) (3)]);
 //BA.debugLineNum = 239;BA.debugLine="bytes2send(4)=bytestosend(4)";
_bytes2send[(int) (4)] = (byte) (_bytestosend[(int) (4)]);
 //BA.debugLineNum = 240;BA.debugLine="bytes2send(5)=bytestosend(5)";
_bytes2send[(int) (5)] = (byte) (_bytestosend[(int) (5)]);
 //BA.debugLineNum = 241;BA.debugLine="bytes2send(6)=bytestosend(6)";
_bytes2send[(int) (6)] = (byte) (_bytestosend[(int) (6)]);
 //BA.debugLineNum = 243;BA.debugLine="chcolor.Color=Colors.ARGB(bytestosend(3), bytesto";
mostCurrent._chcolor.setColor(anywheresoftware.b4a.keywords.Common.Colors.ARGB(_bytestosend[(int) (3)],_bytestosend[(int) (4)],_bytestosend[(int) (5)],_bytestosend[(int) (6)]));
 //BA.debugLineNum = 245;BA.debugLine="End Sub";
return "";
}
}
